/*
 * Copyright 2016 (c) Anna Schumaker.
 */
#ifndef OCARINA_CORE_PLAYLISTS_GENERIC_H
#define OCARINA_CORE_PLAYLISTS_GENERIC_H
#include <core/playlists/playlist.h>

/* Generic playlist init function. */
void playlist_generic_init(struct playlist *, unsigned int, struct queue_ops *);

/* Generic playlist can-select function. */
bool playlist_generic_can_select(struct playlist *);

/* Generic playlist clear operation. */
void playlist_generic_clear(struct playlist *);

/* Generic playlist add track operations. */
bool playlist_generic_add_track(struct playlist *, struct track *);
bool playlist_generic_add_track_front(struct playlist *, struct track *);

/* Generic playlist remove track operation. */
bool playlist_generic_remove_track(struct playlist *, struct track *);

/* Generic playlist set_flag operation. */
void playlist_generic_set_flag(struct playlist *, enum queue_flags, bool);

/* Generic playlist sorting operation. */
void playlist_generic_sort(struct playlist *, enum compare_t, bool);

/* Generic playlist next track operation. */
struct track *playlist_generic_next(struct playlist *);

#endif /* OCARINA_CORE_PLAYLISTS_GENERIC_H */
